/*
 * Copyright 2012 Adaptrex, LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.adaptrex.core.ext;

import com.fasterxml.jackson.annotation.JsonInclude;

public class Sorter {

	private String		property;
	private String		direction;
	private String		root;
	
	public Sorter(String property, String direction, String root) {
		this.property = property;
		this.direction = direction;
		this.root = root;
	}

	@JsonInclude(JsonInclude.Include.NON_NULL)
	public String getDirection() {
		return direction;
	}

	@JsonInclude(JsonInclude.Include.NON_NULL)
	public String getProperty() {
		return property;
	}

	@JsonInclude(JsonInclude.Include.NON_NULL)
	public String getRoot() {
		return root;
	}
	
}
