/*
 * Copyright 2012 Adaptrex, LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.adaptrex.core.persistence.api;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.adaptrex.core.ext.Filter;
import com.adaptrex.core.ext.Sorter;

public abstract class BaseStoreData {
	private Integer 		start;
	private Integer 		limit;
	private List<Sorter> 	groupers = new ArrayList<Sorter>();
	private List<Sorter> 	sorters = new ArrayList<Sorter>();
	private String 			where;
	private Map<String, Object> params = new HashMap<String,Object>();
	private List<Filter> 	filters = new ArrayList<Filter>();

	private Integer			totalCount;

	protected static SimpleDateFormat dateFormat = new SimpleDateFormat(
			"yyyy-MM-dd");
	
	
	public void setStart(Integer start) {
		this.start = start;
	}

	public void setGroupers(List<Sorter> groupers) {
		this.groupers = groupers;
	}

	public void setSorters(List<Sorter> sorters) {
		this.sorters = sorters;
	}

	public void setWhere(String where) {
		this.where = where;
	}

	public void setParams(Map<String, Object> params) {
		this.params = params;
	}

	public void setFilters(List<Filter> filters) {
		this.filters = filters;
	}

	public Integer getStart() { 
		return start;
	}

	public List<Sorter> getGroupers() {
		return groupers;
	}

	public List<Sorter> getSorters() {
		return sorters;
	}

	public String getWhere() {
		return where;
	}

	public Map<String, Object> getParams() {
		return params;
	}

	public List<Filter> getFilters() {
		return filters;
	}

	public Integer getTotalCount() {
		return totalCount;
	}

	public void setTotalCount(Integer totalCount) {
		this.totalCount = totalCount;
	}
	
	public void setLimit(Integer limit) {
		this.limit = limit;
	}
	
	public Integer getLimit() {
		return limit;
	}
}
