/*
 * Copyright 2012 Adaptrex, LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.adaptrex.core.rest;

import javax.ws.rs.core.UriInfo;

public interface RestService {

	RestStore getStore(String className, UriInfo uriInfo);

	RestStore getStore(String className, UriInfo uriInfo, String factoryName);

	RestModel getModel(String className, Object id, UriInfo uriInfo);

	RestModel getModel(String className, Object id, UriInfo uriInfo,
			String factoryName);

	RestModel createModel(String className, RequestBody modelData,
			UriInfo uriInfo);

	RestModel createModel(String className, RequestBody modelData,
			UriInfo uriInfo, String factoryName);

	RestModel updateModel(String className, Object id, RequestBody modelData,
			UriInfo uriInfo);

	RestModel updateModel(String className, Object id, RequestBody modelData,
			UriInfo uriInfo, String factoryName);

	RestModel deleteModel(String className, Object id);

	RestModel deleteModel(String className, Object id, String factoryName);

}
