/*
 * Copyright 2012 Adaptrex, LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.adaptrex.core.view.jsf;

import java.io.IOException;

import javax.faces.component.FacesComponent;
import javax.faces.component.UIComponentBase;
import javax.faces.context.FacesContext;

import com.adaptrex.core.view.BootstrapComponent;

@FacesComponent("ext.data.Bootstrap") 
public class JSFBootstrapComponent extends UIComponentBase {

	@Override
	public String getFamily() {
		return "ext.data.bootstrap";
	}
	
	@Override
    public void encodeBegin(FacesContext context) throws IOException {
		String extBuild = (String) getAttributes().get("build");
		BootstrapComponent bootstrapComponent = new BootstrapComponent(extBuild);
		context.getResponseWriter().write(bootstrapComponent.toString());
	}
}