/*
 * Copyright 2012 Adaptrex, LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.adaptrex.core.view.jsf;

import java.io.IOException;
import java.util.Map;

import javax.faces.component.FacesComponent;
import javax.faces.component.UIComponentBase;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;

import com.adaptrex.core.view.ConfigComponent;

@FacesComponent("ext.data.Config") 
public class JSFConfigComponent extends UIComponentBase {
	
	@Override
	public String getFamily() {
		return "ext.data.config";
	}
	
	@Override
    public void encodeBegin(FacesContext context) throws IOException {
		ExternalContext external = context.getExternalContext();
		HttpServletRequest request = (HttpServletRequest) external.getRequest();
		
		Map<String,Object> a = getAttributes();
		String webLib			= (String) a.get("weblib");
		String extVersion		= (String) a.get("ext_version");
		String extBuild			= (String) a.get("ext_build");
		String extPath			= (String) a.get("ext_path");
		String extTheme			= (String) a.get("ext_theme");
		
		String touchVersion		= (String) a.get("senchatouch_version");
		String touchPath		= (String) a.get("senchatouch_path");
		String touch			= (String) a.get("senchatouch");
		
		String namespace = (String) a.get("ns");
		if (namespace == null) namespace = (String) a.get("namespace");
		
		ConfigComponent configComponent = new ConfigComponent(request);
		configComponent.setNamespace(namespace);
		
		if (webLib != null)		configComponent.setWeblibPath(webLib);
		if (extVersion != null)	configComponent.setExtVersion(extVersion);
		if (extBuild != null)	configComponent.setExtBuild(extBuild);
		if (extPath != null)	configComponent.setExtPath(extPath);
		if (extTheme != null)	configComponent.setExtTheme(extTheme);
		
		if (touchVersion != null)	configComponent.setSenchaTouchVersion(touchVersion);
		if (touchPath != null)		configComponent.setSenchaTouchPath(touchPath);
		if (touch != null && touch.equals("true")) {
			configComponent.setTouch(true);
		}
		
		context.getResponseWriter().write(configComponent.toString());
	}
}
 