/*
 * Copyright 2012 Adaptrex, LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.adaptrex.core.view.tapestry.components;

import javax.servlet.http.HttpServletRequest;

import org.apache.tapestry5.annotations.Parameter;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.ioc.annotations.Inject;
import org.apache.tapestry5.services.RequestGlobals;

import com.adaptrex.core.view.ModelComponent;

public class Model {

	@Inject	private RequestGlobals requestGlobals;
	
	@Parameter @Property private String ns;
	@Parameter @Property private String namespace;
	@Parameter @Property private String factory;
	@Parameter @Property private String table;
	@Parameter @Property private String name;
	@Parameter @Property private String include;
	@Parameter @Property private String exclude;
	@Parameter @Property private String associations;
	@Parameter @Property private String entityid;
	@Parameter @Property private String entitykey;
	@Parameter @Property private String entityvalue;
	@Parameter @Property private Object rest;
	
	public String getBody() {
		HttpServletRequest request = requestGlobals.getHTTPServletRequest();
		
		if (ns == null) ns = namespace;
		
		ModelComponent modelComponent = new ModelComponent(request, table, factory);
		if (ns != null) 			modelComponent.setNamespace(ns);
		if (name != null)			modelComponent.setModelName(name);
		if (include != null)		modelComponent.setInclude(include);
		if (exclude != null)		modelComponent.setExclude(exclude);
		if (associations != null) 	modelComponent.setAssociations(associations);
		if (entityid != null)		modelComponent.setEntityId(entityid);
		if (entitykey != null)		modelComponent.setEntityKey(entitykey);
		if (entityvalue != null)	modelComponent.setEntityValue(entityvalue);
		
		if (rest != null) 
			modelComponent.setRest(String.valueOf(rest));
		
		return modelComponent.toString();
	}	
	
}
